/*
 * $Id$
 */

package org.sonatype.nexus.rest.model;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Collection;
import java.util.Date;

/**
 * null
 * 
 * @version $Revision$ $Date$
 */
public class ContentListResource implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field resourceURI
     */
    private String resourceURI;

    /**
     * Field relativePath
     */
    private String relativePath;

    /**
     * Field text
     */
    private String text;

    /**
     * Field leaf
     */
    private boolean leaf = false;

    /**
     * Field lastModified
     */
    private java.util.Date lastModified;

    /**
     * Field sizeOnDisk
     */
    private long sizeOnDisk = 0;

    /**
     * Field children
     */
    private java.util.List children;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addChildren
     * 
     * @param contentListResource
     */
    public void addChildren(ContentListResource contentListResource)
    {
        if ( !(contentListResource instanceof ContentListResource) )
        {
            throw new ClassCastException( "ContentListResource.addChildren(contentListResource) parameter must be instanceof " + ContentListResource.class.getName() );
        }
        getChildren().add( contentListResource );
        contentListResource.createContentListResourceAssociation( this );
    } //-- void addChildren(ContentListResource) 

    /**
     * Method breakContentListResourceAssociation
     * 
     * @param contentListResource
     */
    public void breakContentListResourceAssociation(ContentListResource contentListResource)
    {
        if ( ! getChildren().contains( contentListResource ) )
        {
            throw new IllegalStateException( "contentListResource isn't associated." );
        }
        
        getChildren().remove( contentListResource );
    } //-- void breakContentListResourceAssociation(ContentListResource) 

    /**
     * Method createContentListResourceAssociation
     * 
     * @param contentListResource
     */
    public void createContentListResourceAssociation(ContentListResource contentListResource)
    {
        Collection children = getChildren();
        
        if ( getChildren().contains(contentListResource) )
        {
            throw new IllegalStateException( "contentListResource is already assigned." );
        }
        
        children.add( contentListResource );
    } //-- void createContentListResourceAssociation(ContentListResource) 

    /**
     * Method getChildren
     */
    public java.util.List getChildren()
    {
        if ( this.children == null )
        {
            this.children = new java.util.ArrayList();
        }
        
        return this.children;
    } //-- java.util.List getChildren() 

    /**
     * Get null
     */
    public java.util.Date getLastModified()
    {
        return this.lastModified;
    } //-- java.util.Date getLastModified() 

    /**
     * Get null
     */
    public String getRelativePath()
    {
        return this.relativePath;
    } //-- String getRelativePath() 

    /**
     * Get null
     */
    public String getResourceURI()
    {
        return this.resourceURI;
    } //-- String getResourceURI() 

    /**
     * Get null
     */
    public long getSizeOnDisk()
    {
        return this.sizeOnDisk;
    } //-- long getSizeOnDisk() 

    /**
     * Get null
     */
    public String getText()
    {
        return this.text;
    } //-- String getText() 

    /**
     * Get null
     */
    public boolean isLeaf()
    {
        return this.leaf;
    } //-- boolean isLeaf() 

    /**
     * Method removeChildren
     * 
     * @param contentListResource
     */
    public void removeChildren(ContentListResource contentListResource)
    {
        if ( !(contentListResource instanceof ContentListResource) )
        {
            throw new ClassCastException( "ContentListResource.removeChildren(contentListResource) parameter must be instanceof " + ContentListResource.class.getName() );
        }
        contentListResource.breakContentListResourceAssociation( this );
        getChildren().remove( contentListResource );
    } //-- void removeChildren(ContentListResource) 

    /**
     * Set null
     * 
     * @param children
     */
    public void setChildren(java.util.List children)
    {
        this.children = children;
    } //-- void setChildren(java.util.List) 

    /**
     * Set null
     * 
     * @param lastModified
     */
    public void setLastModified(java.util.Date lastModified)
    {
        this.lastModified = lastModified;
    } //-- void setLastModified(java.util.Date) 

    /**
     * Set null
     * 
     * @param leaf
     */
    public void setLeaf(boolean leaf)
    {
        this.leaf = leaf;
    } //-- void setLeaf(boolean) 

    /**
     * Set null
     * 
     * @param relativePath
     */
    public void setRelativePath(String relativePath)
    {
        this.relativePath = relativePath;
    } //-- void setRelativePath(String) 

    /**
     * Set null
     * 
     * @param resourceURI
     */
    public void setResourceURI(String resourceURI)
    {
        this.resourceURI = resourceURI;
    } //-- void setResourceURI(String) 

    /**
     * Set null
     * 
     * @param sizeOnDisk
     */
    public void setSizeOnDisk(long sizeOnDisk)
    {
        this.sizeOnDisk = sizeOnDisk;
    } //-- void setSizeOnDisk(long) 

    /**
     * Set null
     * 
     * @param text
     */
    public void setText(String text)
    {
        this.text = text;
    } //-- void setText(String) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
